/* ========================================================================== */
/*			Xtest13_3.c : 119 Ambulance Sound		      */
/* ========================================================================== */
/*			  Designed and programmed by Duck-Yong Yoon in 2007.  */

#include "AT91SAM7S256.h"
#include "lib_AT91SAM7S256.h"
#include "OK7S256gcc.h"

int main(void)
{
  unsigned int i;

  MCU_initialize();				// initialize AT91SAM7S256 & kit
  Delay_ms(50);					// wait for system stabilization
  LCD_initialize();				// initialize text LCD

  LCD_string(0x80,"  ** SOUND **   ");		// display title
  LCD_string(0xC0," 119 Ambulance  ");

  AT91F_PWMC_CfgPMC();				// enable clock of PWMC
  AT91F_PIO_CfgPeriph(AT91C_BASE_PIOA, SPEAKER, 0); // PWM0 output on PA0

  while(1)
    { AT91F_PWMC_StartChannel(AT91C_BASE_PWMC, AT91C_PWMC_CHID0); // start sound
      for(i=0; i<5; i++)
        { AT91F_PWMC_CfgChannel(AT91C_BASE_PWMC, 0, 0x0204, 6250, 3125);
						// 48MHz/16/6250 = 480Hz
          Delay_ms(500);
          AT91F_PWMC_CfgChannel(AT91C_BASE_PWMC, 0, 0x0204, 8333, 4167);
						// 48MHz/16/8333 = 360Hz
          Delay_ms(500);
        }

      AT91F_PWMC_StopChannel(AT91C_BASE_PWMC, AT91C_PWMC_CHID0);  // stop sound
      Delay_ms(1000);
    }
}
